{-# LANGUAGE UndecidableInstances #-}
{-# LANGUAGE GADTs #-}
{-# LANGUAGE MultiParamTypeClasses #-}
{-# LANGUAGE FlexibleInstances #-}
{-# LANGUAGE FlexibleContexts #-}
{-# LANGUAGE ScopedTypeVariables #-}
module Lam.Binding 
  ( addBinding
  , lookupBinding
  , inScopeVariables
  ) where

import Lam.Lam
import Lam.Language

import Data.Cursor.CLASE.Bound
import Data.Cursor.CLASE.Language
import Data.Cursor.CLASE.Traversal

import Control.Monad.Reader
import Data.Map (Map)
import qualified Data.Map as Map

instance (MonadReader (Map Integer String) m) => Bound Lam (m a)  where
  bindingHook (CW ctx) hole = bindingHook' ctx
    where
      bindingHook' :: ContextI from to -> m a
      bindingHook' (ExpToAbs str _) = addBinding str hole
      bindingHook' _ = hole


addBinding :: MonadReader (Map Integer String) m => String -> m a -> m a
addBinding s = local (Map.insert 0 s . Map.mapKeysMonotonic succ)

lookupBinding :: MonadReader (Map Integer String) m => Integer -> m (Maybe String)
lookupBinding i = liftM (Map.lookup i) ask

inScopeVariables :: Cursor Lam x a -> Map Integer String
inScopeVariables = flip runReader Map.empty . inBindingScope (const ask)
